- name: Install dependencies
  package:
    name:
      - libsystemd-dev
      - git
      - sqlite3
      - pkg-config
      - build-essential
      - python3-dev
      - python3-setuptools
      - python3-venv
      - python3-dbus
      - python3-paramiko
      - dbus-broker
      # dbus-broker is a workaround for systemd#22737 which has issues with dynamic users and dbus

- name: Fetch Forge system
  git:
    repo: "https://gitlab.com/derek.hageman/forge.git"
    dest: /opt/forge
    version: daos

- name: Install Python packages
  pip:
    name:
      - gunicorn
      - systemd-python
    virtualenv_command: /usr/bin/python3 -m venv
    virtualenv: /opt/forge/venv
    virtualenv_site_packages: yes
  register: venv_updated
- name: Upgrade pip
  when: venv_updated.changed
  command:
    argv:
      - /opt/forge/venv/bin/pip
      - install
      - --upgrade
      - pip
    chdir: /opt/forge
  environment:
    TMPDIR: /var/tmp

- name: Check Forge installed
  stat:
    path: /opt/forge/venv/bin/forge-vis
  register: forge_installed
- name: Install Forge
  when: not forge_installed.stat.exists
  command:
    argv:
      - /opt/forge/venv/bin/pip
      - install
      - --compile
      - .
    chdir: /opt/forge
  environment:
    TMPDIR: /var/tmp

- name: Set Forge world read and execute
  file:
    path: /opt/forge
    recurse: true
    mode: a+rX

- name: Copy acquisition units
  copy:
    remote_src: true
    src: /opt/forge/forge/acquisition/systemd/units/
    dest: /etc/systemd/system/
